searchNodes=[{"doc":"Tensorflow lite intepreter for Elixir. Deep Learning inference framework for embedded devices. Basic Usage You get the trained tflite model and save it in a directory that your application can read. &quot;your-app/priv&quot; may be good choice. $ cp your-trained-model.tflite ./priv Next, you will create a module that interfaces with the deep learning model. The module will need pre-processing and post-processing in addition to inference processing, as in the example following. TflInterp provides inference processing only. You put use TflInterp at the beginning of your module, specify the model path as an optional argument. In the inference section, you will put data input to the model ( TflInterp.set_input_tensor/3 ), inference execution ( TflInterp.invoke/1 ), and inference result retrieval ( TflInterp.get_output_tensor/2 ). defmodule YourApp.YourModel do use TflInterp, model: &quot;priv/your-trained-model.tflite&quot; def predict(data) do # preprocess # to convert the data to be inferred to the input format of the model. input_bin = convert-float32-binaries(data) # inference # typical I/O data for Tensorflow lite models is a serialized 32-bit float tensor. output_bin = __MODULE__ |&gt; TflInterp.set_input_tensor(0, input_bin) |&gt; TflInterp.invoke() |&gt; TflInterp.get_output_tensor(0) # postprocess # add your post-processing here. # you may need to reshape output_bin to tensor at first. tensor = output_bin |&gt; Nx.from_binary({:f, 32}) |&gt; Nx.reshape({size-x, size-y, :auto}) * your-postprocessing * ... end end","ref":"TflInterp.html","title":"TflInterp","type":"module"},{"doc":"Get the flat binary from the output tensor on the interpreter. Parameters mod - modules' names or session. index - index of output tensor in the model","ref":"TflInterp.html#get_output_tensor/2","title":"TflInterp.get_output_tensor/2","type":"function"},{"doc":"Get the propaty of the tflite model. Parameters mod - modules' names","ref":"TflInterp.html#info/1","title":"TflInterp.info/1","type":"function"},{"doc":"Invoke prediction. Parameters mod - modules' names","ref":"TflInterp.html#invoke/1","title":"TflInterp.invoke/1","type":"function"},{"doc":"Execute post processing: nms. Parameters mod - modules' names num_boxes - number of candidate boxes num_class - number of category class boxes - binaries, serialized boxes tensor[ num_boxes ][4]; dtype: float32 scores - binaries, serialized score tensor[ num_boxes ][ num_class ]; dtype: float32 iou_threshold - IOU threshold score_threshold - score cutoff threshold sigma - soft IOU parameter","ref":"TflInterp.html#non_max_suppression_multi_class/7","title":"TflInterp.non_max_suppression_multi_class/7","type":"function"},{"doc":"Execute the inference session. In session mode, data input/execution of inference/output of results to the DL model is done all at once. Parameters session - session. Examples. output_bin = session ( ) |&gt; TflInterp . set_input_tensor ( 0 , input_bin ) |&gt; TflInterp . run ( ) |&gt; TflInterp . get_output_tensor ( 0 )","ref":"TflInterp.html#run/1","title":"TflInterp.run/1","type":"function"},{"doc":"Put a flat binary to the input tensor on the interpreter. Parameters mod - modules' names or session. index - index of input tensor in the model bin - input data - flat binary, cf. serialized tensor opts - data conversion","ref":"TflInterp.html#set_input_tensor/4","title":"TflInterp.set_input_tensor/4","type":"function"},{"doc":"Stop the tflite interpreter. Parameters mod - modules' names","ref":"TflInterp.html#stop/1","title":"TflInterp.stop/1","type":"function"},{"doc":"Tensorflow lite interpreter for Elixir. Deep Learning inference framework for embedded devices.","ref":"readme.html","title":"TflInterp","type":"extras"},{"doc":"TflInterp is designed based on the following policy. Provide only the Deep Learning inference. It aims to the poor-resource devices such as IOT and mobile. Easy to understand. The inference part, excluding pre/post-processing, can be written in a few lines. Use trained models from major Deep Learning frameworks that are easy to obtain. Multiple inference models can be used from a single application. There are few dependent modules. It does not have image processing or matrix calculation functions. TflInterp does not block the erlang/elixir process scheduler. It runs as an OS process outside of elixir. The back-end inference engine can be easily replaced. It's easy to keep up with the latest Deep Learninig technology. And I'm trying to make TflInterp easy to install. short or concise history The development of Tflinterp started in 2020 Nov. The original idea was to use Nerves to create an AI remote controlled car. In the first version, I implemented Yolo3, but the design strongly depended on the model, which made it difficult to use in other applications. Reflecting on that mistake, I redesigned Tflinterp according to the above design guidelines.","ref":"readme.html#design-policy-features","title":"TflInterp - Design policy (Features)","type":"extras"},{"doc":"It has been confirmed to work in the following OS environment. Windows MSYS2/MinGW64 WSL2/Ubuntu 20.04 Nerves ARMv6, ARMv7NEON and AArch64","ref":"readme.html#platform","title":"TflInterp - Platform","type":"extras"},{"doc":"cmake 3.18.6 or later git","ref":"readme.html#requirements","title":"TflInterp - Requirements","type":"extras"},{"doc":"Since 0.1.3, the installation method of this module has changed. You may need to remove previously installed TflInterp before installing new version. There are two installation methods. You can choose either one according to your purpose. Like any other elixir module, add TflInterp to the dependency list in the mix.exs. def deps do [ ... { :tfl_interp , github : &quot;shoz-f/tfl_interp&quot; , branch : &quot;nerves&quot; } ] end Download TflInterp to a directory in advance, and add that path to the dependency list in mix.exs. # download TflInterp in advance. $ cd / home / { your home } / workdir $ git clone - b nerves https :// github . com / shoz - f / tfl_interp . git def deps do [ ... { :tfl_interp , path : &quot;/home/{your home}/workdir/tfl_interp&quot; } ] end Then you run the following commands in your application project. For Desktop application: $ mix deps.get $ mix compile For Nerves application: $ export MIX_TARGET=rpi3 # &lt;- specify target device tag $ mix deps.get $ mix firmware It takes a long time to finish the build. Because it will download the required files - Tensorflow sources, ARM toolchain [^1], etc - at the first build time. Method 1 saves the downloaded files under &quot;{your app}/deps/tfl_interp&quot;. On the other hand, method 2 saves them under &quot;/home/{your home}/workdir/tfl_interp&quot;. If you want to reuse the downloaded files in other applications, I recommend Method 2. In either method 1 or 2, the external modules required for Tensorflow lite are stored under &quot;{your app}/_build/{target}/.cmake_build&quot; according to the cmakelists.txt that comes with Tensorflow. [^1] Unfortunately, the ARM toolchain that comes with Nerves can not build Tensorflow lite. We need to get the toolchain recommended by the Tensorflow project. After installation, you will have the directory tree like these: Method 1 work_dir + - your - app + - _build / | + - dev / | + - . cmake_build / -- - CMakeCash . txt and external modules that Tensorflowlite depends on . | | The cmake build outputs are stored here also . | + - lib / | | + - tfl_interp | | + - ebin / | | + - priv | | + - tfl_interp -- - executable : tensorflow interpreter . | : | + - deps / | + tfl_interp | | + - 3 rd_party / -- - Tensorflow sources , etc . | | + - lib / -- - TflInterp module . | | + - src / -- - tfl_interp C ++ sources . | | + - test / | | + - toolchain / -- - ARM toolchains for Nerves . | | + - CMakeLists . txt -- - CMake configuration for for building tfl_interp . | | + - mix . exs | : | + - lib / + - test / + - mix . exs Method 2 work_dir + - your - app | + - _build / | | + - dev / | | + - . cmake_build / -- - CMakeCash . txt and external modules that Tensorflowlite depends on . | | | The cmake build outputs are stored here also . | | + - lib / | | | + - tfl_interp | | | + - ebin / | | | + - priv | | | + - tfl_interp -- - executable : tensorflow interpreter . | | : | | | + - deps / | + - lib / | + - test / | + - mix . exs | + - tfl_interp + - 3 rd_party / -- - Tensorflow sources , etc . + - lib / -- - TflInterp module . + - src / -- - tfl_interp C ++ sources . + - test / + - toolchain / -- - ARM toolchains for Nerves . + - CMakeLists . txt -- - CMake configuration for for building tfl_interp . + - mix . exs","ref":"readme.html#installation","title":"TflInterp - Installation","type":"extras"},{"doc":"You get the trained tflite model and save it in a directory that your application can read. &quot;your-app/priv&quot; may be good choice. $ cp your-trained-model.tflite ./priv Next, you will create a module that interfaces with the deep learning model. The module will need pre-processing and post-processing in addition to inference processing, as in the example following. TflInterp provides inference processing only. You put use TflInterp at the beginning of your module, specify the model path as an optional argument. In the inference section, you will put data input to the model ( TflInterp.set_input_tensor/3 ), inference execution ( TflInterp.invoke/1 ), and inference result retrieval ( TflInterp.get_output_tensor/2 ). defmodule YourApp.YourModel do use TflInterp, model: &quot;priv/your-trained-model.tflite&quot; def predict(data) do # preprocess # to convert the data to be inferred to the input format of the model. input_bin = convert-float32-binaries(data) # inference # typical I/O data for Tensorflow lite models is a serialized 32-bit float tensor. output_bin = __MODULE__ |&gt; TflInterp.set_input_tensor(0, input_bin) |&gt; TflInterp.invoke() |&gt; TflInterp.get_output_tensor(0) # postprocess # add your post-processing here. # you may need to reshape output_bin to tensor at first. tensor = output_bin |&gt; Nx.from_binary({:f, 32}) |&gt; Nx.reshape({size-x, size-y, :auto}) * your-postprocessing * ... end end Let's enjoy ;-)","ref":"readme.html#basic-usage","title":"TflInterp - Basic Usage","type":"extras"},{"doc":"There is MNIST web application in demo_mnist directory. You can do it by following the steps below. $ cd demo_mnist $ mix deps.get $ mix run --no-halt And then, please open your browser with &quot; http://localhost:500&quot;.","ref":"readme.html#demo","title":"TflInterp - Demo","type":"extras"},{"doc":"TflInterp is licensed under the Apache License Version 2.0.","ref":"readme.html#license","title":"TflInterp - License","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Major Features and Improvements add session mode. add processing time measurement function. update Tensorflow to 2.8.0.","ref":"changelog.html#release-0-1-5-apl-4-2022","title":"Changelog - Release 0.1.5(Apl 4 2022)","type":"extras"},{"doc":"Bug Fixes and Other Changes adjust word alignment of NMS parameter to ARMs.","ref":"changelog.html#release-0-1-4-feb-6-2022","title":"Changelog - Release 0.1.4(Feb 6 2022)","type":"extras"},{"doc":"Breaking Changes change installation methods. see README.md for detail. Major Features and Improvements move the directory to download Tensorflow to &quot;3rd_party&quot;. supported Nerves ARMv6, ARMv7NEON and AArch64(not yet tested). Bug Fixes and Other Changes corrected CMakeLists scripts for MSYS2/MinGW64. revised demo_mnist to fit cimg_ex 0.1.8.","ref":"changelog.html#release-0-1-3-jan-30-2022","title":"Changelog - Release 0.1.3(Jan 30 2022)","type":"extras"},{"doc":"Breaking Changes Major Features and Improvements remove C++ code that depend on C++20 features: src/tfl_interp.cc. limit dependency of mix_cmake to dev . Bug Fixes and Other Changes","ref":"changelog.html#release-0-1-2-jan-17-2022","title":"Changelog - Release 0.1.2(Jan 17 2022)","type":"extras"}]